## TCL-part of piecharts for StatWWW
## author: Mikko Pikarinen, goblet@goblet.net 1998-1999
## Tested with Eggdrop 1.3.22 only.
## see pie.README for information of usage!!!
## This is free to use but don't remove the info about original author.

## MAKE THE SETTINGS for piechannels list and htmlpath a few lines below!

proc do_pies {min hour day month year} {

  set piechannels {#bLeRp}
  set htmlpath "/home/httpd/html/stat"

  foreach chan $piechannels { 
    toptenfile $chan
    exec ./pie.pl $chan >pie.gif

    set chan [string tolower [string range $chan 1 end]]
    for {set i 1} {$i < 31} {incr i} {
          catch {
            set infile "$htmlpath/pie-$chan-[expr 30 - $i].gif"
            set outfile "$htmlpath/pie-$chan-[expr 31 - $i].gif"
            file rename -force $infile $outfile
            }
        }
    file rename -force pie.gif $htmlpath/pie-$chan-0.gif
  }
}

proc toptenfile {chan} {
  set chan [string tolower $chan]
  set total 0
  set foolist [lrange [sortbywords $chan] 0 9]
  foreach i $foolist {
    set total [expr $total + [lindex $i 0]]
  }
  foreach i $foolist {
    set foo "[format %.1f [expr 100.0*[lindex $i 0]/$total]] [lindex $i 1]"
    lappend percentlist $foo
  }
  set outfile "pie.[string range $chan 1 end].dta"
  set fd [open $outfile w]
  foreach i $percentlist {puts $fd $i}
  close $fd
}
if {$tcl_version < 7.6} {
    putlog "pie.tcl: TCL $tcl_version found"
    putlog "pie.tcl: WARNING! At least TCL 7.6 required!"
   }

bind time - "59 23 % % %" do_pies
putlog "Piecharts v1.0 for StatWWW by Goblet"
